<!DOCTYPE html>
<html lang="pt-br">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- As 3 meta tags acima *devem* vir em primeiro lugar dentro do `head`; qualquer outro conteúdo deve vir *após* essas tags -->
  <title>Servidor de e-mail com Postfix</title>

  <!-- Bootstrap -->
  <link href="assets/css/bootstrap.min.css" rel="stylesheet">
  <link href="assets/css/estilo.css" rel="stylesheet">

  <!-- HTML5 shim e Respond.js para suporte no IE8 de elementos HTML5 e media queries -->
  <!-- ALERTA: Respond.js não funciona se você visualizar uma página file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
  </head>
  <body>
    <div class="container">
      <div class="col-xs-12">
        <nav class="navbar navbar-default">
          <div class="container-fluid">
            <!-- Brand and toggle get grouped for better mobile display -->
            <div class="navbar-header">
              <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
              </button>
            </div>

            <!-- Collect the nav links, forms, and other content for toggling -->
            <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
              <ul class="nav navbar-nav">
                <li><a href="#postfix">Informações </a></li>
                <li><a href="#instalacaoinit">Postfix</a></li>
                <li><a href="#dovecot">Dovecot</a></li>
                <li><a href="#PHP">PHP</a></li>
                <li><a href="#MySQL">MySQL</a></li>
                <li><a href="#roundcube">RoundCube</a></li>
                <li><a href="#tree">Árvore de diretórios</a></li>
                <li><a href="#client">Cliente de e-mail</a></li>
                <li><a href="#download">Download</a></li>
              </ul>
            </div><!-- /.navbar-collapse -->
          </div><!-- /.container-fluid -->
        </nav>
      </div>
      <div class="col-xs-12">
        <h1>Servidor de e-mails com Postfix</h1>
      </div>

      <!-- Explicação Postfix-->
      <div class="col-xs-12">
        <a name='postfix'></a>
        <h2>Postfix</h2>
        <p>
          A ideia  inicial do Postfix era a de produzir um substituto para o Sendmail que fosse “rápido, fácil de administrar e seguro”. Trata-se de um projeto OpenSource patrocinado pela IBM, criado e mantido por  Wietse Venema, Ph.D. em Física pela Groningen University na Holanda. Segundo seu criador, o projeto e o desenvolvimento do Postfix foram norteados pelas seguintes diretrizes:
        </p>
        <ul>
          <li><strong>Confiabilidade:</strong> o sistema é capaz de manter seu funcionamento mesmo diante de condições adversas como falta de memória ou mesmo espaço em disco. Nesses casos, o sistema tenta reduzir sua atividade para facilitar a retomada de condições por parte do servidor</li>
          <li><strong>Segurança:</strong> o Postfix é composto por componentes diferentes. Cada componente é executado com o mínimo de privilégios necessários para o desempenho de suas funções, de forma que um componente com níveis mais elevados de privilégios nunca “confie” em outros que possuam níveis inferiores. Além disso, o sistema possui recursos para minimizar a possibilidade de ataques dos tipos buffer overflow e DoS (Denial of Service), dentre outros. Um dos próprios slogans do Postfix é “Security by Design” que ratifica o fato de que aspectos de segurança foram considerados desde sua concepção</li>
          <li><strong>Desempenho:</strong> o Postfix possui recursos capazes de colaborar com o desempenho geral do sistema operacional no qual está sendo executado por meio da limitação, por exemplo, dos processos criados e dos acessos ao sistema de arquivos necessários para o processamento de mensagens</li>
          <li><strong>Flexibilidade:</strong> essa diretriz diz respeito ao fato dos componentes do Postfix serem independentes permitindo customizações individuais que facilitam a especialização das configurações e a manutenção de suas funcionalidades.</li>
        </ul>
        <p>
          O Postfix se consolidou como uma alternativa ao Sendmail em razão de suas características técnicas tais como maior robustez, melhor desempenho e maior facilidade na manutenção e configuração. Entretanto, conforme citado anteriormente, para facilitar sua adoção em ambientes Unix, onde o Sendmail era (e ainda é) bastante popular, o Postfix manteve diversos comandos e arquivos compatíveis com os do Sendmail. Essa alternativa evita, por exemplo, a necessidade de mudança de scripts e softwares já desenvolvidos considerando os recursos do Sendmail. 
        </p>
        <p>
          Outra característica importante do Postfix é a sua arquitetura modularizada. Ou seja, ao contrário da estrutura monolítica do Sendmail onde apenas um processo é o responsável por todas as atividades relacionadas com o processamento de mensagens, no caso do Postfix vários componentes são os responsáveis pelo funcionamento do sistema.  Essa arquitetura, além de facilitar a manutenção do código e a implementação de novas funcionalidades, agrega algumas importantes características de segurança dentre as quais a possibilidade de evitar e/ou minimizar os impactos de eventuais ataques como os de buffer overflow, por exemplo.
        </p>
        <p>
          Obviamente não se pode preterir uma boa infraestrutura para implantação da solução de groupware, sendo que a aplicação e todos os seus componentes devem sempre estar disponíveis aos usuários.
        </p>

        <p> 
          Para que o Postfix funcione com um cliente web, será necessária a instalação e configuração dos seguintes recrusos: 
          <ul>
            <li>Servidor web <b>Nginx</b></li>
            <li>Servidor de e-mail <b>Postfix</b></li>
            <li>Servidor IMAP/POP3 <b>Dovecot</b></li>
            <li>SGDB <b>MySQL</b></li>
            <li><b>PHP5</b></li>
          </ul>
        </p>
      </div>

      <!-- Instalação Postfix -->
      <div class="col-xs-12">
        <a name='instalacaoinit'></a>

        <h2>Instalação</h2>
        <p>
          A função deste arquivo é garantir a instalação do postfix de forma correta. Para isso, inicialmente ele verifica se o arquivo main.cf, já configurado, foi copiado para dentro da instância. Após isso é realizada a instalação do postfix, e o seu serviço é iniciado. <br> Também é instalado o mailutils, para facilitar a checagem e envio de emails através da instância.
        </p>
        <h1>Postfix</h1>
        <h3>init.pp</h3>

        <pre><code>
          class postfix {


          #Realiza a instalação do pacote postfix, garantindo que o system-update foi realizado
          package { 'postfix': 
          require => Class["system-update"], # para garantir que o pacote esteja disponivel e atualizado
          ensure  => present,
        }   

        #Realiza a instalação do pacote mailutils
        package { 'mailutils':
        require => Class["system-update"],
        ensure => present,
      }

      #Inicializa o serviço postfix, após garantir que o arquivo de configuração (main.cf) foi criado com sucesso
      service { 'postfix':
      ensure  => running,
      enable  => true,
      hasrestart => true,
      hasstatus => true,
      require => File['/etc/postfix/main.cf'],
    }


    #Copia o arquivo main.cf para dentro da pasta do postfix, com as informações de configuração do mesmo
    file { '/etc/postfix/main.cf':
    source => 'puppet:///modules/arquivos/postfix/main.cf',
    owner   => 'root',
    group   => 'root',
    mode    => 644,
    require => Package['postfix'],
    notify  => Service['postfix'],
  }

}
</code></pre>
</div>


<div class="col-xs-12">
  <h3>main.cf</h3>
  <pre><code>
    myorigin = $myhostname
    mydomain = local.domain
    mydestination = $myhostname, localhost.$mydomain, localhost $mydomain
    mynetworks = "Sua Rede"/24 #Ex: 192.168.1.0/24
    relay_domains = 
    #relayhost = "seuip" #Ex: 192.168.1.170
  </code></pre>
  <h3>Explicando o main.cf</h3>
  <p><li>O parâmetro myorigin especifica o domínio que aparece no correio que está publicado nesta máquina.</li>
   <li>O parâmetro mydomian especifica o “domínio pai” de $myhostname. Por padrão, ele é derivado de $myhostname  removendo a primeira parte (a menos que o resultado seja um domínio de nível superior).</li>
   <li>Por outro lado, se você especificar mydomain em main.cf, como fizermos no nosso servidor, o Postfix usará seu valor para gerar um valor padrão totalmente qualificado para o parâmetro myhostname.</li>
   <li>Para consultar o exemplo de configuração acesse o arquivo “main.cf” em /modules/arquivos/postfix/files.</li></p>
 </div>



 <div class="col-xs-12">
   <a name="dovecot"></a>

   <h1>Dovecot</h1>
   <h3>init.pp</h3>
   <pre><code>
    class dovecot {

    #Realiz a instalação do dovecot, se certificando de que o postfix já foi instalado
    package { ['dovecot-common', 'dovecot-imapd']:
    ensure => installed,
    require => Class['postfix']
  }

  #Inicializa o serviço do dovecot imap
  service { 'dovecot':
  ensure  => 'running',
  require => Package['dovecot-imapd']
}

#Copia os arquivos de configuração do dovecot para as respectivas pastas
file { 'dovecot.conf':
require => Package['dovecot-imapd'],
path    => '/etc/dovecot/dovecot.conf',
ensure  => file,
owner   => 'root',
group   => 'root',
mode    => '0644',
source  => 'puppet:///modules/dovecot/dovecot.conf';
} 

file { '10-auth.conf':
require => File['dovecot.conf'],
path    => '/etc/dovecot/conf.d/10-auth.conf',
ensure  => file,
owner   => 'root',
group   => 'root',
mode    => '0644',
source  => 'puppet:///modules/dovecot/conf.d/10-auth.conf';
} 

file { '10-mail.conf':
require => File['10-auth.conf'],
notify  => Service['dovecot'],
path    => '/etc/dovecot/conf.d/10-mail.conf',
ensure  => file,
owner   => 'root',
group   => 'root',
mode    => '0644',
source  => 'puppet:///modules/dovecot/conf.d/10-mail.conf';
} 

file { '20-imap.conf':
require => File['20-imap.conf'],
notify  => Service['dovecot'],
path    => '/etc/dovecot/conf.d/20-imap.conf',
ensure  => file,
owner   => 'root',
group   => 'root',
mode    => '0644',
source  => 'puppet:///modules/dovecot/conf.d/20-imap.conf';
}    
}

</code></pre>

<h3>10-mail.conf</h3>

Dentro do arquivo 10-mail.conf é realizada a configuração de onde estão localizados os e-mails recebidos no servidor, indicando que eles estão dentro da pasta /var/mail/nomeDoUsuario.
<pre><code>
  mail_location = mbox:~/mail:INBOX=/var/mail/%u
</code></pre>

</div>

<div class="col-xs-12">
 <a name="PHP"></a>

 <h1>PHP</h1>
 A instalação do PHP se dá de forma simples, sendo apenas realizada a instalação do pacote, e garantia de que o serviço estará rodando. Não são necessárias configurações adicionais.
 <h3>init.pp</h3>
 <pre><code>
  #Realiza o download e instalação do pacote php5-fpm
  class php5 {
  package { "php5-fpm": 
  require => Class["system-update"], # para garantir que o pacote esteja disponivel e atualizado
  ensure  => installed,
}

#Garante que o serviço do php estará rodando após a instalação do pacote
service { "php5-fpm":
ensure  => "running",
require => Package["php5-fpm"],
}

}

</code></pre>

</div>

<div class="col-xs-12">
 <a name="MySQL"></a>

 <h1>MySQL</h1>
 A instalação do MySQL se dá de forma simples e igual à do PHP, sendo apenas realizada a instalação do pacote, e garantia de que o serviço estará rodando. Não são necessárias configurações adicionais. O usuário criado para o MySQL é "root", sem nenhuma senha configurada.
 <h3>init.pp</h3>
 <pre><code>
  class mysql {
  #Realiza o download e instalação do pacote mysql-server
  package { "mysql-server": 
  require => Class["system-update"], # para garantir que o pacote esteja disponivel e atualizado
  ensure  => installed,
}
#Garante que o serviço do mysql estará rodando após a instalação do pacote
service { "mysql":
ensure  => "running",
require => Package["mysql-server"],
}

}


</code></pre>

</div>

<div class="col-xs-12">
 <a name="roundcube"></a>

 <h1>RoundCube</h1>
 <h3>init.pp</h3>

<pre><code>
class roundcube {

  #Instala os pacotes do Roundcube, garantindo que o Nginx já esteja instalado, e que o serviço do MySQL esteja rodando.
  package { ['roundcube', 'roundcube-plugins', 'roundcube-plugins-extra']:
    ensure => installed,
    require => [Class['nginx'], Service['mysql']],
    notify => Service['php5-fpm']
  }

  #Cria um link da pasta do Roundcube para a pasta do servidor web.
  exec { 'config-nginx':
    command => 'ln -s /var/lib/roundcube /usr/share/nginx/www/',
    require => Package['roundcube']
  }

  #Envia o arquivo de configuração do banco de dados do Roundcube a partir de um template pré-configurado
  file { '/etc/roundcube/debian-db.php':
    require => Package['roundcube'],
    ensure => file,
    content => template('roundcube/debian-db.php.erb')
  }

  #Envia o arquivo de configuração do Roundcube a partir de uma template pré-configurado
  file { '/etc/roundcube/main.inc.php':
    require => Package['roundcube'],
    ensure => file,
    content => template('roundcube/main.inc.php.erb')
  }
}
</code></pre>

<h3>main.inc.php.erb</h3>
Neste arquivo é importante se atentar à configuração do host ao qual o roundcube irá se conectar por padrão, e à IP do Servidor SMTP, alterando os mesmos conforme necessidade.
<pre><code>
$rcmail_config['default_host'] = '192.168.33.16';
$rcmail_config['smtp_server'] = '192.168.33.16';
</code></pre>

<h3>debian-db.php.erb</h3>
Neste arquivo são realizadas as configurações do MySQL, não há necessidade de realizar alterações no mesmo, visto que está sendo conectado como root sem senha.

</div>
<div class="col-xs-12">
  <a name='client'></a>
  <h3>Como enviar e-mail</h3>
  <p><li>Para acessar e escrever emails deve-se acessar a página 192.168.33.16/roundcube, ou o IP por você definido no arquivo Vagrantfile. Feito isso você será redirecionado a página de login do roundcube, o usuário e senha de login são ambos "vagrant". 
  <p><li>Passado login você será redirecionado a página do servidor de emails onde poderá enviar emails exclusivamente para usuários do domínio @redes2.trabalho. Como teste pode ser encaminhado um email para vagrant@redes2.trabalho.</p></li>	
  <p><li>ATENÇÃo! Antes de abrir o webmail é necessário acessar a maquina via ssh e executar o comando "sudo service nginx restart". Estamos trabalhando em uma solução para esse problema, assim que o mesmo for resolvido mandamos uma nova versão.</li></p>
</div>

<div class="col-xs-12">
  <a name='tree'></a>
  <h2>Estrutura de arquivos</h2>
  <p>
    A estrutura de aquivos do box é a seguinte:
  </p>
  <img src="assets\img\tree.jpg">
  <br>
</div>
</body>
</html>
